#define __OWN__HW_H__
#include "__HW.h"
#undef __OWN__HW_H__


void EE_W(u16 wAddr, u8 bData)
{
	while (*EECR & EEPE) ;
	*EEAR=wAddr;
	*EEDR=bData;
	CLI();
	*EECR = EEMPE;
	*EECR = EEPE;
	SEI();
}

u8 EE_R(u16 wAddr)
{
	while (*EECR & EEPE) ;
	*EEAR = wAddr;
	*EECR = EERE;
	return *EEDR;
}


//vvvvvvvvvvvvvvvvvvvvvvvv  DATA OUTPUT vvvvvvvvvvvvvvvvvvvvvvvvv

u8f bfPrefix[4]={' ','0','_','.'};
u8 baDecodeBuf[12];

u8 DummyPrint(u8 bChar) { return 0; }

u8 ITOA(u8 bData) { if ( (bData=(bData&0x0F)+'0')>'9' ) bData+=7; return bData; }

u8 _c(u8 bByte) { return (*gl_psPrintChar)(bByte); }

void _x4(u8 bData) { _c(ITOA(bData)); }
void _x8(u8 bData) { _x4(bData>>4); _x4(bData); }
void _x16(u16 wData) { _x8(HIBYTE(wData)); _x8(LOBYTE(wData)); }
void _x32(u32 dwData) {	_x16(HIWORD(dwData)); _x16(LOWORD(dwData)); }

void _x(u32 dwData, u8 bSize)
{
	u8 bCnt, j;
	j=bfPrefix[bSize>>6]; bSize&=0x0F;
	bCnt=0;
	do { baDecodeBuf[bCnt++]=ITOA(dwData); } while ( dwData>>=4 ) ;
	if ( bSize ) { while ( bSize>bCnt ) { _c(j); bSize--; } ; } else bSize=bCnt;
	do { _c(baDecodeBuf[--bCnt]); } while ( --bSize );
}

void _d(u32 dwData, u8 bSize, u8 bPoint)
{
	u8 bCnt, j;
	u32 dwk;

	j=bfPrefix[bSize>>6]; bSize&=0x0F;
	bCnt=0;
	do {
		baDecodeBuf[bCnt++]=(dwData-10*(dwk=dwData/10))+0x30; if ( bCnt==bPoint ) baDecodeBuf[bCnt++]='.';
	} while ( (dwData=dwk) || (( bCnt<(bPoint+2) ) && (bPoint) ) ) ;
	if ( bSize ) { while ( bSize>bCnt ) { _c(j); bSize--; } ; } else bSize=bCnt;
	do { _c(baDecodeBuf[--bCnt]); } while ( --bSize );

}

void _s(u8* pStr) { if ( pStr ) while ( _c(*pStr++) ) ; }
void _sF(u8f* pfStr) { if ( pfStr ) while ( _c(*pfStr++) ) ; }
u8 strlen(u8* pbStr) { u8 i=0; if ( pbStr ) { while ( *(pbStr++) ) i++; } return i; }
u8 strlenf(u8f* pfbStr) { u8 i=0; if ( pfbStr ) { while ( *(pfbStr++) ) i++; } return i; }

//^^^^^^^^^^^^^^^^^^^^  DATA OUTPUT ^^^^^^^^^^^^^^^^^^^^^^^

void delay_100us(u16 wTime) { u8 i; while ( wTime-- ) { i=10; while ( --i); while ( --i); } } // 256+10=266x => 100us
void delay_ms(u16 wDelay) { CLI(); gl_wT2_Delay_ms=wDelay; do { SEI(); SLEEP(); CLI(); } while ( gl_wT2_Delay_ms ); SEI();}

void Start_T1(u8 bPrescale) { *TCCR1B=TIM1_STOP; gl_wT1Cnt=0; *TCCR1A=OC1A_DIS|OC1B_DIS; *TCNT1L=*TCNT1H=0; *TCCR1B=bPrescale; }
u16 Stop_T1(void) { *TCCR1B=TIM1_STOP; if ( !gl_wT1Cnt ) gl_wT1Cnt=*TCNT1; return gl_wT1Cnt; }


// system timer: Timer2 0...249 @250kHz = 1ms

#define BUTTONCOUNTDOWN 100
#define BUZZER_ON_BUTTON 50
u8 b_ButtonCntDown;
u8 b_ButtonPrev;
#define SYS_TIME_DIVIDER 8
u8 bSysTimeDivide, bRotDivide;

#pragma vector=IRQ_TIM2CA
__interrupt void fIRQ_TIM2CA(void)
{
	u8 bButtonRaw;

	if ( gl_wRotCnt ) {
		if ( bRotDivide ) --bRotDivide;
		else {
			STRONG_1(A4988_STEP);
			if ( !(--gl_wRotCnt) ) gl_bState&=~STAT_ROTATING;
			bRotDivide=gl_bRotDiv-1;
			STRONG_0(A4988_STEP);
		}
	}

	if ( bSysTimeDivide ) --bSysTimeDivide;
	else {
		*ADMUX=ADCREF_BGAP|ADLAR|ADC_BUTTONS; *ADCSRA=ADEN|ADSC|ADC_500K;
		++gl_dwSysTime;
		if (  gl_wT2_Delay_ms ) --gl_wT2_Delay_ms;
		if ( gl_bBuzzerCntDown ) { if ( !(--gl_bBuzzerCntDown) ) STRONG_0(BUZZER_IO); }

		while ( *ADCSRA & ADSC );
		if ( (bButtonRaw=*ADCH)>250 ) gl_bButton=b_ButtonPrev=BUT_NO;
		else {
			if			( bButtonRaw>200 )	bButtonRaw=BUT_DN;	// DOWN
			else if ( bButtonRaw>140 )	bButtonRaw=BUT_RT;	// RIGHT
			else if ( bButtonRaw> 80 )	bButtonRaw=BUT_OK;	// ENTER
			else if ( bButtonRaw> 30)		bButtonRaw=BUT_UP;	// UP
			else 												bButtonRaw=BUT_LT;	// LEFT
			if ( bButtonRaw==b_ButtonPrev ) {
				if ( (b_ButtonCntDown) && (!(--b_ButtonCntDown)) ) { gl_bButton=b_ButtonPrev; BUZZER(BUZZER_ON_BUTTON); }
			}
			else { b_ButtonCntDown=BUTTONCOUNTDOWN; b_ButtonPrev=bButtonRaw; }
		}
		bSysTimeDivide=SYS_TIME_DIVIDER-1;
	}
}

u8 GetButton(void)
{
	while ( gl_bButton!=BUT_NO ) ;
	while ( gl_bButton==BUT_NO ) ;
	return 	gl_bButton;
}

/*
//~~~~~~~~~~~~~~~~~ ADC ~~~~~~~~~~~~~~~~~~~~~

u8 ADC_Get8(u8 bRefMux, u8 bDivider)
{
// ADLAR(ADMUX)=1, read only ADCH
	if ( (bRefMux&0x0F)<6 ) *DIDR0|=(1<<(bRefMux&0x0F));	// disable PCx digital input
	*ADCSRA=ADEN|(bDivider&0x07);
	*ADMUX=bRefMux;
	*ADCSRA=ADEN|ADSC|(bDivider&0x07); while ( *ADCSRA & ADSC ) ;
	return (*ADCH);
}

// bCnt<=64 so that no u16 overflow by 10-bit ADCs
u16 ADC_Get10(u8 bRefMux, u8 bDivider, u8 bCnt)
{
// ADLAR(ADMUX)=0, read ADCL, ADCH

	u16 wTmp;
	if ( (bRefMux&0x0F)<6 ) *DIDR0|=(1<<(bRefMux&0x0F));	// disable PCx digital input
	*ADCSRA=ADEN|(bDivider&0x07);
	*ADMUX=bRefMux;
	wTmp=0; do { *ADCSRA=ADEN|ADSC|(bDivider&0x07); while ( *ADCSRA & ADSC ) ; wTmp+=(*ADC); } while ( (bCnt--)>1 ) ;
	return wTmp;
}

//~~~~~~~~~~~~~~~~~ ADC ~~~~~~~~~~~~~~~~~~~~~
*/
/*
//~~~~~~~~~~~~~~~~~~~ IRQs ~~~~~~~~~~~~~~~~~~~~~
#pragma vector=IRQ_PCINT0
__interrupt void sIRQ_PCINT0(void) { ManageIRQ(GPIO_B); }

#pragma vector=IRQ_PCINT1
__interrupt void sIRQ_PCINT1(void) { ManageIRQ(GPIO_C); }

#pragma vector=IRQ_PCINT2
__interrupt void sIRQ_PCINT2(void) { ManageIRQ(GPIO_D); }
//~~~~~~~~~~~~~~~~~~~ IRQs ~~~~~~~~~~~~~~~~~~~~~
*/

void InitBoard(void)
{
	OUT_MODE(BUZZER_IO); STRONG_0(BUZZER_IO);
	OUT_MODE(ARDULED); STRONG_0(ARDULED);
//	OUT_MODE(PC4); STRONG_0(PC4);
//	OUT_MODE(PC5); STRONG_0(PC5);

	*ADCSRA=ADEN|ADC_125K;
	*ADMUX=ADCREF_BGAP|ADLAR|ADC_BUTTONS;
	gl_bBuzzerCntDown=b_ButtonCntDown=b_ButtonPrev=0;

	bSysTimeDivide=bRotDivide=0;
	gl_dwSysTime=0L;
	gl_wT2_Delay_ms=gl_wT1Cnt=0;
	gl_wRotCnt=0;
	gl_bState=0;

	*TCNT2=0;											// Timer2=0 (on reset clk_T2=0 - timer2 stopped)
	*OCR2A = 250-1;										// Timer2 count 0...249 @250kHz / 250 = 1kHz IRQ, 1ms
	*TCCR2A = OC2A_DIS | OC2B_DIS | TIM2_A_CTC_OCR2A;	// operation mode "Clear Timer on Compare", count 0...249
	*TCCR2B = TIM2_B_CTC_OCR2A|TIM2_2M;				// start Timer0 on f= fmaster/8 - 2MHz, 4us/tick
	*TIMSK2 = OCIE2A;									// enable interrupt on OCR2A compare @8kHz

	gl_psPrintChar=&DummyPrint;
	LCD_init();
//	while ( gl_dwSysTime<40L );	// wait 40 mS after powerUp
	delay_ms(100);
}
