#ifndef __HW_H__
#define __HW_H__

#include "__Atmega328.h"
#include "__LCD1602.h"
#include "__A4988.h"

#define ARDULED		_CHN(GPIO_B,5)	//	5		.		.		O	Arduino LED - SPI SCK
#define PC4		_CHN(GPIO_C,4)
#define PC5		_CHN(GPIO_C,5)
#define ADC_BUTTONS	ADC6
#define	BUZZER_IO		_CHN(GPIO_C,1)
#define PHOTOA			_CHN(GPIO_C,2)
#define PHOTOB			_CHN(GPIO_C,3)


#define	LCD_4BITPORT	GPIO_D
#define	LCD_4BITMASK	0xF0
#define	LCD_EN			_CHN(GPIO_D,3)
#define	LCD_RS			_CHN(GPIO_D,2)

#define	A4988_EN		_CHN(GPIO_B,0)
#define	A4988_DIR		_CHN(GPIO_B,2)
#define	A4988_STEP	_CHN(GPIO_B,1)

#define BUT_NO	0
#define BUT_UP	4
#define BUT_DN	1
#define BUT_LT	5
#define BUT_RT	2
#define BUT_OK	3



#undef GLOBAL
#ifdef __OWN__HW_H__
#define GLOBAL
#else
#define GLOBAL extern
#endif

GLOBAL u16 gl_wRotCnt;
GLOBAL u8 gl_bRotDiv;
GLOBAL u32 gl_dwSysTime;
GLOBAL u16 gl_wT2_Delay_ms, gl_wT1Cnt;
GLOBAL u8 (*gl_psPrintChar)(u8);
GLOBAL u8 gl_bButton;
GLOBAL u8 gl_bState;
GLOBAL u8 gl_bBuzzerCntDown;


void EE_W(u16 wAddr, u8 bData);
u8 EE_R(u16 wAddr);

// gl_bState
#define STAT_NEWBUTTON	BIT(0)
#define STAT_ROTATING	BIT(1)


#define _SPACE	(0<<6)
#define _ZERO		(1<<6)
#define _UNDER	(2<<6)
#define _POINT	(3<<6)

u8 _c(u8 bByte);
void _x4(u8 bData);
void _x8(u8 bData);
void _x16(u16 wData);
void _x32(u32 dwData);
void _x(u32 dwData, u8 bSize);
void _d(u32 dwData, u8 bSize, u8 bPoint);
void _s(u8* pSrc);
void _sF(u8f* pfSrc);
#define _s_sF(dData) do { static u8f c[]=dData; _sF(c); } while(0)
u8 strlen(u8* sStr);
u8 strlenf(u8f* sStr);


//~~~~~~~~~~~~~~~~~ ADC ~~~~~~~~~~~~~~~~~~~~~
u8  ADC_Get8 (u8 bRefMux, u8 bDivider);
u16 ADC_Get10(u8 bRefMux, u8 bDivider, u8 bCnt);
//~~~~~~~~~~~~~~~~~ ADC ~~~~~~~~~~~~~~~~~~~~~

//~~~~~~~~~~~~~~~~~~~ IRQs ~~~~~~~~~~~~~~~~~~~~~
#define NO_PULLUP 0
#define PULLUP 1
void AddIRQ(u8 bChan, u8 bPullup, void (*_fCallBack)(u8) );
void DelIRQ(u8 bChan);
//~~~~~~~~~~~~~~~~~~~ IRQs ~~~~~~~~~~~~~~~~~~~~~


void Start_T1(u8 bPrescale);
#define Get_T1() (gl_wT1Cnt=*TCNT1)
u16 Stop_T1(void);
void delay_100us(u16 wTime);
void delay_ms(u16 wDelay);
void InitBoard(void);
#define BUZZER(bTime) do { if ( gl_bBuzzerCntDown<bTime ) { gl_bBuzzerCntDown=bTime; STRONG_1(BUZZER_IO); } } while(0)
#define MEM_F_CPY(pfSrc,pDst,bCnt) do { u8 i=bCnt; while ( i-- ) { pDst[i]=pfSrc[i]; } } while(0)
#define MEM_FILL(bByte,pDst,bCnt) do {  u8 i=bCnt; while ( i-- ) { pDst[i]=bByte; } } while(0)
u8 GetButton(void);

#endif