#ifndef __LCD1602__
#define __LCD1602__

#define LCD_ROWS 	 2
#define LCD_COLUMNS 16
#define LCD_BUFSIZE (LCD_ROWS*LCD_COLUMNS)	// 32 buffer

// LCD Commands (RS=0)

#define LCD_DISPLAYON 0x0C		// display ON, cursor & blink=OFF
#define LCD_DISP_BLINK 0x01		// blink=ON
#define LCD_DISP_CURSOR 0x02	// cursor=ON
#define LCD_SETCGRAM_AC 0x40	// set CG AC
#define LCD_SETDDRAM_AC 0x80	// set RAM AC=0x00...0x27 (1st line) 0x40...0x67 (2nd line)


#undef GLOBAL
#ifdef __OWN__LCD1602__
#define GLOBAL
#else
#define GLOBAL extern
#endif

GLOBAL u8 gl_b_LCD_X, gl_b_LCD_Y;

#define CG_UP		0x00
#define CG_DN		0x01
#define CG_UPDN	0x02
#define CG_RT		0x03
#define CG_LT		0x04
#define CG0			0x08
#define CG1			0x09
#define CG2			0x0A
#define CG3			0x0B
#define CG4			0x0C
#define CG5			0x0D
#define CG6			0x0E
#define CG7			0x0F

void LCD_init(void);
u8 LCD_Char(u8 bData);
void LCD_Command(u8 bCommand);
//void LCD_ClearBuf(void);
void LCD_Clear(void);
void LCD_ClearToEOL(void);
//void LCD_OnOffCursor(u8 bCursor);

#define LCD_BUFPUT(bData) do { ba_LCD_I_Buf[gl_b_LCD_Y*LCD_COLUMNS+(gl_b_LCD_X++)]=bData; } while(0)
#define LCD_MoveCursor(bPos)	LCD_Command(gl_bLCDNextAddr=GetAC(bPos))
#define LCD_CursorOn()			LCD_Command(LCD_DISP_CURSOR|LCD_DISPLAYON)
#define LCD_CursorOff()			LCD_Command(LCD_DISPLAYON)

#endif