/*
registers

	R0-R3	scratch		(4)
	R4-R15	preserved
	R16-R23	scratch, args	(8)
	R24-R25	preserved
	R26-R27 X - preserved
	R28-R29	Y - stack pointer
	R30-R31	Z - scratch	(2)

external variables

	EXTERN e1

stack allocation

        CALL    ?PROLOGUE6_L09
        REQUIRE ?Register_R4_is_cg_reg
        REQUIRE ?Register_R5_is_cg_reg

division	R16

        LDI     R20, 10
        MOV     R16, R24
        CALL    ?UC_DIVMOD_L01

UC - unsigned char
US - unsigneg int
S

mul u16*u16					: R17:16 = R17:16 * R21:20 - CALL ?S_EC_MUL_L02
div u16/u16, mod u16%u16	: R17:16 = R17:16 / R21:20, R21:20 = R17:16 % R21:20 - CALL ?US_DIVMOD_L02
div u8/u8, mod u8%u8		: R16 = R16/R20, R20 = R16 % R20 - CALL ?UC_DIVMOD_L01
        LDI     R20, 10
        MOV     R16, R24
        CALL    ?UC_DIVMOD_L01


*/

			NAME		__LowLevel

			PUBLIC		BCD_to_Num
			PUBLIC		Num_to_BCD
			PUBLIC		u8_div_u8
			PUBLIC		u8_div_10
			PUBLIC		TFT_x1_
			PUBLIC		TFT_x2_
			PUBLIC		TFT_x4_
			PUBLIC		TFT_x8_
			PUBLIC		TFT_d2_
			PUBLIC		Nib_to_Dig

			EXTERN		TFT_c

			RSEG	CODE:CODE:NOROOT(1)

//	R16=R16/R17, R20=R16%R17
u8_div_10:	LDI		R17, 10
u8_div_u8:	CLR		R20
			LDI		R30,8
__loop__:	LSL		R16
			ROL		R20
			CP		R20,R17
			BRCS	__skip__
			INC		R16
			SUB		R20,R17
__skip__:	DEC		R30
			BRNE	__loop__
			RET

//		BCD -> normal
BCD_to_Num:	MOV     R17, R16
			ANDI    R16, 0x0F
			SWAP    R17
			ANDI    R17, 0x0F
			LDI     R18, 10
			MUL     R17, R18
			ADD     R16, R0
			RET

Num_to_BCD:	RCALL	u8_div_10
			SWAP	R16
			ADD		R16, R20
			RET

Nib_to_Dig:	ANDI	R16,0x0F
			ORI		R16,'0'
			CPI		R16,'9'+1
			BRCS	__l001__
			SUBI    R16, -7
__l001__:	RET



TFT_d2_:	RCALL	Num_to_BCD
			RJMP	TFT_x2_

TFT_x8_:	ST      -Y, R16
			ST		-Y, R17
			ST		-Y, R18
			MOV		R16,R19
			RCALL	TFT_x2_
			LD      R16, Y+
			RCALL	TFT_x2_
			LD      R16, Y+
			RJMP	__l002__
TFT_x4_:	ST      -Y, R16
			MOV		R16,R17
__l002__:	RCALL	TFT_x2_
			LD      R16, Y+
TFT_x2_:	ST      -Y, R16
			SWAP    R16
			RCALL	TFT_x1_
			LD      R16, Y+
TFT_x1_:	RCALL	Nib_to_Dig
			JMP		TFT_c



        END
