#include "__HW.h"

#define VAR_SHOW 0xFE

u8f sfCamera0[]="S95";
u8f sfCamera1[]="30D";
u8f sfCamera2[]="EM5";
u8sf pfsfCameras[]={sfCamera0,sfCamera1,sfCamera2};
#define MAX_CAMERA (sizeof(pfsfCameras)/sizeof(u8sf)-1)

enum EepromVariables {
	E_SHOTS,
	E_SPEED,
	E_CAMERA,
	E_CAMDEL0A, E_CAMDEL0B, E_CAMDEL0C,
	E_CAMDEL1A, E_CAMDEL1B, E_CAMDEL1C,
	E_CAMDEL2A, E_CAMDEL2B, E_CAMDEL2C,
	E_STEPS, E_USTEPS, E_SMALLGT2, E_BIGGT2,
	E_SIG0, E_SIG1, E_MAX};

u8f bfEV[]={
	5,						// E_SHOTS
	3,						// E_SPEED = 2kHz
	0,						// E_CAMERA
	2,10,20,				// S95 time delays A, B, C in 0.1s
	2,2,2,				// 30D time delays A, B, C in 0.1s
	2,2,2,				// EM5 time delays A, B, C in 0.1s
	200,					// E_STEPS
	0,						// E_USTEPS
	16,						// E_SMALLGT2
	90,						// E_BIGGT2
	0xBD, 0xDB		// signature
};
u8 bEV[E_MAX];

#define MAX_SHOTS 99
u8 baShots[MAX_SHOTS];
u8 g_bMaxShots;
u8 g_bCurShots;

u32 dw_uStepsRound;

u8 g_bDir;

#define WAITSTABLE 200
void RoTable(void)
{
	STRONG_1(A4988_EN);
	if ( g_bDir==0x02 )	STRONG_0(A4988_DIR);
	else if ( g_bDir==0x01 )	STRONG_1(A4988_DIR);
	else return;
	STRONG_0(A4988_EN);
	gl_bRotDiv=1<<bEV[E_SPEED];
	gl_wRotCnt=dw_uStepsRound/baShots[g_bCurShots];	gl_bState|=STAT_ROTATING;	while ( gl_bState&STAT_ROTATING );
	delay_ms(WAITSTABLE);
	STRONG_1(A4988_EN);
}

void menu_Shots(u8 bChoice)
{
	u8 bShot;

	g_bDir=0x03;

	switch (bChoice){
	case VAR_SHOW:	_s_sF("Shots:   "); if ( g_bMaxShots ) _d(baShots[g_bCurShots],2,0); else _s_sF("--"); break;
	case BUT_LT:	if ( g_bMaxShots && g_bCurShots ) bEV[E_SHOTS]=baShots[--g_bCurShots]; break;
	case BUT_RT:	if ( g_bMaxShots && (g_bCurShots<g_bMaxShots-1) ) bEV[E_SHOTS]=baShots[++g_bCurShots]; break;
	case BUT_OK:
		if ( !g_bMaxShots ) return;
		bEV[E_SHOTS]=baShots[g_bCurShots];
		LCD_Clear(); _s_sF("= EEPROM WRITE ="); bShot=E_SIG0; while ( bShot-- ) EE_W(bShot, bEV[bShot]);
		while ( gl_bButton!=BUT_NO );
		do {
			LCD_Clear(); if ( g_bDir&0x02 ) _s_sF("<-"); gl_b_LCD_X=(LCD_COLUMNS-6)/2; _s_sF("SELECT"); gl_b_LCD_X=LCD_COLUMNS-2; if ( g_bDir&0x01 )_s_sF("->");
			gl_b_LCD_Y=1; gl_b_LCD_X=(LCD_COLUMNS-8)/2; _s_sF("Shots:"); _d(baShots[g_bCurShots],2,0);
				switch ( GetButton() ) {
				case BUT_UP:
				case BUT_DN:
					return;
				case BUT_OK:
					if ( g_bDir!=0x03 ) {
						LCD_Clear(); if ( g_bDir&0x02 ) _s_sF("<-"); gl_b_LCD_X=(LCD_COLUMNS-6)/2; _s_sF("READY?"); gl_b_LCD_X=LCD_COLUMNS-2; if ( g_bDir&0x01 )_s_sF("->");
						gl_b_LCD_Y=1; gl_b_LCD_X=(LCD_COLUMNS-8)/2; _s_sF("Shots:"); _d(baShots[g_bCurShots],2,0);
						if ( GetButton()==BUT_OK ) {
							u8 i;
							u32 dwWaitTill;
							bShot=0;
							while ( (bShot++) < baShots[g_bCurShots] ) {
								LCD_Clear();
								gl_b_LCD_Y=1; gl_b_LCD_X=(LCD_COLUMNS-10)/2; _s_sF("Shot:"); _d(bShot,2,0); _c('/'); _d(baShots[g_bCurShots],2,0);
								switch ( bEV[E_CAMERA] ) {
									case 0:	SOFT_STRONG_1(PHOTOA); SOFT_STRONG_1(PHOTOB); break;
									case 1:	SOFT_STRONG_1(PHOTOA); SOFT_STRONG_1(PHOTOB);	break;
									case 2:	SOFT_STRONG_1(PHOTOA); SOFT_STRONG_1(PHOTOB);	break;
								}
								i=bEV[E_CAMDEL0A+3*bEV[E_CAMERA]];
								while ( i-- ) { BUZZER(20); delay_ms(100); };
								BUZZER(20);
								switch ( bEV[E_CAMERA] ) {
									case 0:	WEAK_OUT_MODE(PHOTOB); WEAK_OUT_MODE(PHOTOA); break;
									case 1:	WEAK_OUT_MODE(PHOTOB); WEAK_OUT_MODE(PHOTOA); break;
									case 2:	WEAK_OUT_MODE(PHOTOB); WEAK_OUT_MODE(PHOTOA); break;
								}
								delay_ms(100*bEV[E_CAMDEL0A+3*bEV[E_CAMERA]+1]);
								dwWaitTill=gl_dwSysTime+100L*bEV[E_CAMDEL0A+3*bEV[E_CAMERA]+2];
/*
								gl_b_LCD_Y=0;
								i=0;
								while ( i++<LCD_COLUMNS ) {
									if ( g_bDir & 0x02 ) { gl_b_LCD_X=LCD_COLUMNS-i; _c('<'); }
									else { gl_b_LCD_X=i-1; _c('>'); }
									delay_ms(200);
								}
*/
								RoTable();

								while ( gl_dwSysTime<dwWaitTill );
							}
							BUZZER(250); delay_ms(500); BUZZER(250);
							return;
						}
					}
				break;
			case BUT_LT:
				if ( g_bDir==0x02 ) RoTable();
				g_bDir=0x02;
				break;
			case BUT_RT:
				if ( g_bDir==0x01 ) RoTable();
				g_bDir=0x01;
				break;
			}
		} while (1);
	}
}


void menu_Speed(u8 bChoice)
{
	switch (bChoice){
	case VAR_SHOW:
		_s_sF("Speed: 1/"); _d(1<<bEV[E_SPEED],3,0);
		break;
	case BUT_LT:
		if ( bEV[E_SPEED]<7 ) bEV[E_SPEED]++;
		break;
	case BUT_RT:
		if ( bEV[E_SPEED] ) bEV[E_SPEED]--;
		break;
	}
}

void menu_Camera(u8 bChoice)
{
	switch (bChoice){
	case VAR_SHOW:
		_s_sF("Camera:  "); _sF(pfsfCameras[bEV[E_CAMERA]]);
		break;
	case BUT_LT:
		if ( bEV[E_CAMERA] ) bEV[E_CAMERA]--;
		break;
	case BUT_RT:
		if ( bEV[E_CAMERA]<MAX_CAMERA ) bEV[E_CAMERA]++;
		break;
	}
}

void menu_CamDelay(u8 bChoice, u8 bDelay)
{
	u8 bIdx=E_CAMDEL0A+3*bEV[E_CAMERA]+bDelay;
	switch (bChoice){
	case VAR_SHOW:
		_sF(pfsfCameras[bEV[E_CAMERA]]); _s_sF(" Del"); _c('A'+bDelay); _s_sF(": "); _d(bEV[bIdx],3,1); _c('s');
		break;
	case BUT_LT:
		if ( bEV[bIdx]>1 ) bEV[bIdx]--;
		break;
	case BUT_RT:
		if ( bEV[bIdx]<99 ) bEV[bIdx]++;
		break;
	}
}


void menu_CamDelayA(u8 bChoice) { menu_CamDelay(bChoice,0); }
void menu_CamDelayB(u8 bChoice) { menu_CamDelay(bChoice,1); }
void menu_CamDelayC(u8 bChoice) { menu_CamDelay(bChoice,2); }

void menu_Steps(u8 bChoice)
{
	switch (bChoice){
	case VAR_SHOW:
		_s_sF("Steps/360:"); _d(bEV[E_STEPS],3,0);
		break;
	case BUT_LT:
		if ( bEV[E_STEPS]>1 ) bEV[E_STEPS]--;
		break;
	case BUT_RT:
		if ( bEV[E_STEPS]<255 ) bEV[E_STEPS]++;
		break;
	}
}

void menu_uSteps(u8 bChoice)
{
	switch (bChoice){
	case VAR_SHOW:
		_s_sF("uSteps/Stp:"); _d(1<<bEV[E_USTEPS],2,0);
		break;
	case BUT_LT:
		if ( bEV[E_USTEPS] ) bEV[E_USTEPS]--;
		break;
	case BUT_RT:
		if ( bEV[E_USTEPS]<6 ) bEV[E_USTEPS]++;
		break;
	}
}

void menu_SmallGT2(u8 bChoice)
{
	switch (bChoice){
	case VAR_SHOW:
		_s_sF("Pinion:   "); _d(bEV[E_SMALLGT2],3,0);
		break;
	case BUT_LT:
		if ( bEV[E_SMALLGT2]>1 ) bEV[E_SMALLGT2]--;
		break;
	case BUT_RT:
		if ( bEV[E_SMALLGT2]<255 ) bEV[E_SMALLGT2]++;
		break;
	}
}

void menu_BigGT2(u8 bChoice)
{
	switch (bChoice){
	case VAR_SHOW:
		_s_sF("Gear:     "); _d(bEV[E_BIGGT2],3,0);
		break;
	case BUT_LT:
		if ( bEV[E_BIGGT2]>1 ) bEV[E_BIGGT2]--;
		break;
	case BUT_RT:
		if ( bEV[E_BIGGT2]<255 ) bEV[E_BIGGT2]++;
		break;
	}
}

void (*p_menu[])(u8 bCoice)={
	&menu_Shots,
	&menu_Speed,
	&menu_Camera,
	&menu_CamDelayA, &menu_CamDelayB, &menu_CamDelayC,
	&menu_Steps, &menu_uSteps, &menu_SmallGT2, &menu_BigGT2};
#define MAX_MENU (sizeof(p_menu)/sizeof(u8sf)-1)

u8 bMenuTop, bMenuCur;
//u16 wTotalSteps;

__noreturn void main(void)
{
	u8 bRow, bTmp;
	u32 dwFullTime;

	SEI();

	OUT_MODE(A4988_EN);		STRONG_1(A4988_EN);
	OUT_MODE(A4988_DIR);
	OUT_MODE(A4988_STEP);

	InitBoard();


	if ( (bfEV[E_SIG0]==EE_R(E_SIG0)) && (bfEV[E_SIG1]==EE_R(E_SIG1)) ) {
		bTmp=E_SIG0; while ( bTmp-- ) bEV[bTmp]=EE_R(bTmp);
	}
	else {
		bTmp=E_MAX; while ( bTmp-- ) EE_W(bTmp, bEV[bTmp]=bfEV[bTmp]);
	}

jReInit:;
	bMenuTop=bMenuCur=0;

	do {
		g_bCurShots=g_bMaxShots=0;
		if ( ! ((dw_uStepsRound=((((u32)bEV[E_BIGGT2])<<bEV[E_USTEPS])*bEV[E_STEPS])) %((u32)bEV[E_SMALLGT2]))  ) {
			dw_uStepsRound/=bEV[E_SMALLGT2];
			bRow=3; while ( (++bRow)<MAX_SHOTS ) if ( !(dw_uStepsRound%bRow) ) baShots[g_bMaxShots++]=bRow;
			g_bCurShots=g_bMaxShots;
			do { --g_bCurShots; } while ( g_bCurShots && (baShots[g_bCurShots]>bEV[E_SHOTS] ) ) ;
			if ( (g_bCurShots!=(g_bMaxShots-1)) && ((bEV[E_SHOTS]-baShots[g_bCurShots]) > (baShots[g_bCurShots+1]-bEV[E_SHOTS])) ) ++g_bCurShots;
		}
		LCD_Clear();
		if ( bMenuCur>=E_STEPS) {
			if ( g_bMaxShots ) { bRow=0; while ( (gl_b_LCD_X<(LCD_COLUMNS-2)) && (bRow<g_bMaxShots) ) { _c(' '); _d(baShots[bRow++],0,0); }; }
			else _s_sF("--");
		}
		else switch m( bMenuCur ) {
		case E_SHOTS:
			dwFullTime=(dw_uStepsRound*(1<<bEV[E_SPEED]))/(800L*baShots[g_bCurShots])+2L;
			dwFullTime=MAX(dwFullTime,bEV[E_CAMDEL0A+3*bEV[E_CAMERA]+2]);
			dwFullTime=(dwFullTime+bEV[E_CAMDEL0A+3*bEV[E_CAMERA]]+bEV[E_CAMDEL0A+3*bEV[E_CAMERA]+1])*baShots[g_bCurShots]+5L;
			gl_b_LCD_X=(LCD_COLUMNS-12)/2;
			_s_sF("t=");
			_d(dwFullTime,0,1);
			_s_sF("s, OK?");
			break;
		case E_CAMERA:
			bTmp=E_CAMDEL0A+3*bEV[E_CAMERA];
			_s_sF("  A"); _d(bEV[bTmp++],3,1); _s_sF(" B"); _d(bEV[bTmp++],3,1); _s_sF(" C"); _d(bEV[bTmp++],3,1);
			break;
		}

		bRow=bMenuTop;
		while (++gl_b_LCD_Y<LCD_ROWS) {
			gl_b_LCD_X=0;
			_x4(bRow); _c( ((bRow)==bMenuCur) ? 0x7E : ' '); (*p_menu[bRow++])(VAR_SHOW);
		}

		switch ( GetButton() ) {
		case BUT_UP:
			if ( bMenuCur>bMenuTop ) bMenuCur--;
			else if ( bMenuTop ) { bMenuTop--; bMenuCur--; }
			break;
		case BUT_DN:
			if ( bMenuCur<(bMenuTop+LCD_ROWS-2) ) bMenuCur++;
			else if ( bMenuCur<MAX_MENU ) { bMenuTop++; bMenuCur++; }
			break;
		case BUT_OK:
			if ( bMenuCur ) goto jReInit;
		default:
			(*p_menu[bMenuCur])(gl_bButton);
			break;
		}
	} while (1);
}
